package com.powerflasher.demo 
{
	import com.pblabs.engine.PBE;
	import com.pblabs.engine.components.TickedComponent;
	import com.pblabs.engine.entity.IEntityComponent;
	import com.pblabs.engine.entity.PropertyReference;
	import com.pblabs.rendering2D.DisplayObjectScene;
	import com.pblabs.rendering2D.IScene2D;

	import flash.events.MouseEvent;
	import flash.geom.Point;

	public class ClickMover extends TickedComponent 
	{
		public var positionReference : PropertyReference;
		public var rotationReference : PropertyReference;
		public var scene : IScene2D;
		private var targetPos : Point;
		private var rotationDir : int = 1;
		private var rotationSpeed : Number = 8;
		private var moveSpeed : Number = 6;

		public override function onTick(tickRate : Number) : void 
		{
			var comp : IEntityComponent = PBE.lookupComponentByType("Scene", DisplayObjectScene);
			DisplayObjectScene(comp).sceneView.addEventListener(MouseEvent.CLICK, onClick);
			
			var position : Point = owner.getProperty(positionReference);
			var rotation : Number = owner.getProperty(rotationReference);
			if (targetPos != null) 
			{
				var dir : Point = targetPos.subtract(position);
				var targetRotation : Number = getTargetRotation();
				
				var dist : Number = dir.length;
				if (dist >= moveSpeed) 
				{
					dir.normalize(moveSpeed);
					position = position.add(dir);
				}
				if (rotation <= targetRotation - 10 || rotation >= targetRotation + 10)
				{
					rotation += rotationSpeed * rotationDir;
					if (rotation > 360)
						rotation = rotation - 360;
					;
					if (rotation < 0)
						rotation = 360 + rotation;
				}
			}
			owner.setProperty(positionReference, position);
			owner.setProperty(rotationReference, rotation);
		}

		private function getTargetRotation() : Number 
		{
			var position : Point = owner.getProperty(positionReference);
			var dir : Point = targetPos.subtract(position);
			var angleRadian : Number = Math.atan2(dir.y, dir.x);
			var angleDegrees : Number;
			angleDegrees = (angleRadian * 180) / Math.PI;
			if (angleDegrees < 0) 
			{
				angleDegrees = 360 + angleDegrees;
			}
			return angleDegrees;
		}

		private function onClick(event : MouseEvent) : void 
		{
			rotationDir = 1;
			targetPos = new Point(event.stageX - 400, event.stageY - 300);
			var targetRotation : Number = getTargetRotation();
			var rotation : Number = owner.getProperty(rotationReference);
			if (targetRotation > rotation) 
			{
				if (targetRotation - rotation > 180)
					rotationDir = -1;
			} 
			else 
			{
				if (rotation - targetRotation < 180)
					rotationDir = -1;
			}
		}
	}
}
